## ros-dashing-rmw-cyclonedds-cpp 0.7.0

=== CMakeLists.txt ===
# Copyright 2018 ADLINK Technology Limited.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

cmake_minimum_required(VERSION 3.5)

project(rmw_cyclonedds_cpp)

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

find_package(ament_cmake_ros REQUIRED)

find_package(rcutils REQUIRED)

find_package(cyclonedds_cmake_module REQUIRED)
find_package(CycloneDDS QUIET CONFIG)
if(NOT CycloneDDS_FOUND)
  message(WARNING "Could not find Eclipse Cyclone DDS - skipping '${PROJECT_NAME}'")
  ament_package()
  return()
endif()

find_package(rmw REQUIRED)
find_package(rosidl_generator_c REQUIRED)
find_package(rosidl_typesupport_introspection_c REQUIRED)
find_package(rosidl_typesupport_introspection_cpp REQUIRED)

ament_export_dependencies(rcutils)
ament_export_dependencies(rmw)
ament_export_dependencies(rosidl_generator_c)
ament_export_dependencies(rosidl_typesupport_introspection_c)
ament_export_dependencies(rosidl_typesupport_introspection_cpp)

add_library(rmw_cyclonedds_cpp
  src/rmw_node.cpp
  src/serdata.cpp
  src/serdes.cpp
  src/graphrhc.cpp
  src/u16string.cpp
  src/exception.cpp
  src/deserialization_exception.cpp
  src/Serialization.cpp
  src/TypeSupport2.cpp)

target_include_directories(rmw_cyclonedds_cpp PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:include>
)

target_link_libraries(rmw_cyclonedds_cpp CycloneDDS::ddsc)

ament_target_dependencies(rmw_cyclonedds_cpp
  "rcutils"
  "rosidl_typesupport_introspection_c"
  "rosidl_typesupport_introspection_cpp"
  "rmw"
  "rosidl_generator_c"
)

configure_rmw_library(rmw_cyclonedds_cpp)

target_compile_definitions(${PROJECT_NAME}
  PRIVATE
    RMW_VERSION_MAJOR=${rmw_VERSION_MAJOR}
    RMW_VERSION_MINOR=${rmw_VERSION_MINOR}
    RMW_VERSION_PATCH=${rmw_VERSION_PATCH}
)

# Causes the visibility macros to use dllexport rather than dllimport,
# which is appropriate when building the dll but not consuming it.
target_compile_definitions(${PROJECT_NAME}
  PRIVATE "RMW_CYCLONEDDS_CPP_BUILDING_LIBRARY")

ament_export_include_directories(include)
ament_export_libraries(rmw_cyclonedds_cpp)

register_rmw_implementation(
  "c:rosidl_typesupport_c:rosidl_typesupport_introspection_c"
  "cpp:rosidl_typesupport_cpp:rosidl_typesupport_introspection_cpp")

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  ament_lint_auto_find_test_dependencies()
endif()

ament_package()

install(
  DIRECTORY include/
  DESTINATION include
)

install(
  TARGETS rmw_cyclonedds_cpp
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

=== debian/changelog ===
ros-dashing-rmw-cyclonedds-cpp (0.7.0-1bionic) bionic; urgency=high

  * Provide a dummy readcdr function if needed
  * Fix serialization on non-32-bit, big-endian systems (#159 <https://github.com/ros2/rmw_cyclonedds/issues/159>)
  * implement safer align_ function (#141 <https://github.com/ros2/rmw_cyclonedds/issues/141>)
  * Enable use of Cyclone DDS security features (#123 <https://github.com/ros2/rmw_cyclonedds/issues/123>)
  * Clean up package xml dependencies (#132 <https://github.com/ros2/rmw_cyclonedds/issues/132>)
  * API changes to sync with one Participant per Context change in rmw_fastrtps (#106 <https://github.com/ros2/rmw_cyclonedds/issues/106>)
  * Improve security logic and memory management
  * Include incompatible_qos_events_statuses.h only if rmw >= 0.8.2
  * Fix memory leaks
  * Support for ON_REQUESTED_INCOMPATIBLE_QOS and ON_OFFERED_INCOMPATIBLE_QOS events (#125 <https://github.com/ros2/rmw_cyclonedds/issues/125>)
  * Update conditional compile logic
  * uncrustify (#124 <https://github.com/ros2/rmw_cyclonedds/issues/124>)
  * Enable use of Cyclone DDS security features
  * Prevent undefined behavior when serializing empty vector (#122 <https://github.com/ros2/rmw_cyclonedds/issues/122>)
  * Add rmw_*_event_init() functions (#115 <https://github.com/ros2/rmw_cyclonedds/issues/115>)
  * Contributors: Dan Rose, Erik Boasson, Ivan Santiago Paunovic, Miaofei Mei, Sid Faber, dodsonmg, eboasson

 -- Erik Boasson <erik.boasson@adlinktech.com>  Tue, 15 Sep 2020 05:00:00 -0000

ros-dashing-rmw-cyclonedds-cpp (0.5.1-1bionic) bionic; urgency=high

  * Use a list instead of a set for node names list
  * Update for changes on Cyclone DDS security branch
  * Fix leak in client/service topic error handling
  * Fix sertopic referencing
  * Update usage of rmw_topic_endpoint_info_array (#101 <https://github.com/ros2/rmw_cyclonedds/issues/101>)
  * Correct std::hash return type sizes (#102 <https://github.com/ros2/rmw_cyclonedds/issues/102>)
  * Correct the coding style to pass CI test.
  * Update for cyclonedds changes needed for ros1 bridge
  * Fix MSBuild warnings C4146 and C4267
  * Add #if version >= 0.8.2 to fix ros2 dashing builds
  * Implementation for rmw_get_pub/sub_info_by_topic (#97 <https://github.com/ros2/rmw_cyclonedds/issues/97>)
  * Remove unused CMake extras (#84 <https://github.com/ros2/rmw_cyclonedds/issues/84>)
  * code style only: wrap after open parenthesis if not in one line (#95 <https://github.com/ros2/rmw_cyclonedds/issues/95>)
  * Support for deadline, lifespan and liveliness qos  (#88 <https://github.com/ros2/rmw_cyclonedds/issues/88>)
  * rmw_get_topic_endpoint_info doesn't exist on Dashing (#91 <https://github.com/ros2/rmw_cyclonedds/issues/91>)
  * dds_time_t instead of dds_duration_t for absolute time
  * Stubs for rmw_get_publishers_info_by_topic and rmw_get_subscriptions_info_by_topic (#81 <https://github.com/ros2/rmw_cyclonedds/issues/81>)
  * Cache serialization info when CDRWriter is constructed (#80 <https://github.com/ros2/rmw_cyclonedds/issues/80>)
  * Mark code that should be unreachable (#77 <https://github.com/ros2/rmw_cyclonedds/issues/77>)
  * Clean up topic namespace prefixes (#76 <https://github.com/ros2/rmw_cyclonedds/issues/76>)
  * Serialize into initialized memory, not vector (#75 <https://github.com/ros2/rmw_cyclonedds/issues/75>)
  * Rework serialization (#42 <https://github.com/ros2/rmw_cyclonedds/issues/42>)
  * Use rcutils_get_env() instead of getenv() (#71 <https://github.com/ros2/rmw_cyclonedds/issues/71>) (#72 <https://github.com/ros2/rmw_cyclonedds/issues/72>)
  * Contributors: Erik Boasson, Dan Rose, Ivan Santiago Paunovic, Dirk Thomas, Dennis Potman, Emerson Knapp, Michael Carroll

 -- Erik Boasson <erik.boasson@adlinktech.com>  Thu, 12 Mar 2020 05:00:00 -0000

ros-dashing-rmw-cyclonedds-cpp (0.4.4-1bionic) bionic; urgency=high

  * Minor CMakeLists cleanup
  * Contributors: Dan Rose

 -- Erik Boasson <erik.boasson@adlinktech.com>  Tue, 19 Nov 2019 06:00:00 -0000

ros-dashing-rmw-cyclonedds-cpp (0.4.3-1bionic) bionic; urgency=high

  * Address "Precondition not met" on rmw_create_node (#65 <https://github.com/ros2/rmw_cyclonedds/issues/65>) (#66 <https://github.com/ros2/rmw_cyclonedds/issues/66>)
  * Fix dashing breakage (#64 <https://github.com/ros2/rmw_cyclonedds/issues/64>)
  * Support localhost-only communications (#60 <https://github.com/ros2/rmw_cyclonedds/issues/60>)
  * Contributors: eboasson

 -- Erik Boasson <erik.boasson@adlinktech.com>  Wed, 13 Nov 2019 06:00:00 -0000

ros-dashing-rmw-cyclonedds-cpp (0.4.2-1bionic) bionic; urgency=high

  * Suppress a syntax error identified by cppcheck 1.89 (#59 <https://github.com/ros2/rmw_cyclonedds/issues/59>)
    Signed-off-by: Scott K Logan <mailto:logans@cottsay.net>
  * Make RMW version acceptable to MSVC (#58 <https://github.com/ros2/rmw_cyclonedds/issues/58>)
    GCC and Clang support the ternary operator in macros, MSVC does not.
    Signed-off-by: Erik Boasson <mailto:eb@ilities.com>
  * skip compilation of rmw_cyclonedds when cyclone dds is not found (#56 <https://github.com/ros2/rmw_cyclonedds/issues/56>)
    * skip compilation of rmw_cyclonedds when cyclone dds is not found
    Signed-off-by: Karsten Knese <mailto:karsten@openrobotics.org>
    * proper case and company name
    Signed-off-by: Karsten Knese <mailto:karsten@openrobotics.org>
    * linters
    Signed-off-by: Karsten Knese <mailto:karsten@openrobotics.org>
    * change ADLINK to Eclipse
    Signed-off-by: Karsten Knese <mailto:karsten@openrobotics.org>
  * remove executive flags from source code files
    Signed-off-by: Karsten Knese <mailto:karsten@openrobotics.org>
  * Contributors: Karsten Knese, Scott K Logan, eboasson

 -- Erik Boasson <erik.boasson@adlinktech.com>  Fri, 01 Nov 2019 05:00:00 -0000

ros-dashing-rmw-cyclonedds-cpp (0.4.1-1bionic) bionic; urgency=high

  * rename return functions
  * Solve the lint issue.
  * Add already obsoleted loaned message interfaces


=== debian/control ===
Source: ros-dashing-rmw-cyclonedds-cpp
Section: misc
Priority: optional
Maintainer: Erik Boasson <erik.boasson@adlinktech.com>
Build-Depends: debhelper (>= 9.0.0), ros-dashing-ament-cmake-ros, ros-dashing-ament-lint-auto, ros-dashing-ament-lint-common, ros-dashing-cyclonedds, ros-dashing-cyclonedds-cmake-module, ros-dashing-rcutils, ros-dashing-rmw, ros-dashing-rosidl-generator-c, ros-dashing-rosidl-typesupport-introspection-c, ros-dashing-rosidl-typesupport-introspection-cpp, ros-dashing-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-dashing-rmw-cyclonedds-cpp
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-dashing-cyclonedds, ros-dashing-cyclonedds-cmake-module, ros-dashing-rcutils, ros-dashing-rmw, ros-dashing-rosidl-generator-c, ros-dashing-rosidl-typesupport-introspection-c, ros-dashing-rosidl-typesupport-introspection-cpp, ros-dashing-ros-workspace
Description: Implement the ROS middleware interface using Eclipse CycloneDDS in C++.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/dashing/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/dashing/setup.sh" ]; then . "/opt/ros/dashing/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/dashing" \
		-DAMENT_PREFIX_PATH="/opt/ros/dashing" \
		-DCMAKE_PREFIX_PATH="/opt/ros/dashing"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/dashing/setup.sh" ]; then . "/opt/ros/dashing/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/dashing/setup.sh" ]; then . "/opt/ros/dashing/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/dashing/setup.sh" ]; then . "/opt/ros/dashing/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-dashing-rmw-cyclonedds-cpp//opt/ros/dashing/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/dashing/setup.sh" ]; then . "/opt/ros/dashing/setup.sh"; fi && \
	dh_auto_install
